'use strict';function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}module.exports = function (BaseWebServer, MockEndpointRegistration, Logger, ControllerRegistration, _) {var
  MockWebServer = function (_BaseWebServer) {_inherits(MockWebServer, _BaseWebServer);
    function MockWebServer() {_classCallCheck(this, MockWebServer);var _this = _possibleConstructorReturn(this,
      _BaseWebServer.call(this));
      _this.useDefaults = false;return _this;
    }MockWebServer.prototype.

    registerMiddleware = function registerMiddleware() {
      _BaseWebServer.prototype.registerMiddleware.call(this);
      this.registerFixtureHandler();
      this.registerMockEndpoints();
      ControllerRegistration.register(this.app, this);
    };

    // eslint-disable-next-line
    MockWebServer.prototype.registerControllers = function registerControllers() {
    };MockWebServer.prototype.

    registerMockEndpoints = function registerMockEndpoints() {
      Logger.log('Attempting to register mock-endpoints - Use Defaults (' + this.useDefaults + ')');
      MockEndpointRegistration.register(this.app, this, this.useDefaults);
    };MockWebServer.prototype.

    registerFixtureHandler = function registerFixtureHandler() {
      Logger.log('Registering the fixtures handler middleware');

      this.app.post('/fixtures', this.handleFixtureRequest.bind(this));
      this.app.post('/v2/fixtures', this.handleFixtureRequestV2.bind(this));
      this.app.post('/v3/fixtures', this.handleFixtureRequestV3.bind(this));
    };MockWebServer.prototype.

    handleFixtureRequest = function handleFixtureRequest(req, res) {
      res.send(_.map(req.body.fixtures, this.mapFixture.bind(this)));
    };MockWebServer.prototype.

    handleFixtureRequestV2 = function handleFixtureRequestV2(req, res) {
      res.send(_.map(req.body.fixtures, this.mapFixtureV2.bind(this)));
    };MockWebServer.prototype.

    mapFixture = function mapFixture(fixture) {
      this[fixture.endpoint + 'MockEndpoint'].andCallMethod(fixture.method);
      return fixture;
    };MockWebServer.prototype.

    mapFixtureV2 = function mapFixtureV2(fixture) {
      this['' + fixture.endpoint].andCallMethod(fixture.method);
      return fixture;
    };MockWebServer.prototype.

    handleFixtureRequestV3 = function handleFixtureRequestV3(req, res) {
      res.send(_.map(req.body.fixtures, this.mapFixtureV3.bind(this)));
    };MockWebServer.prototype.

    mapFixtureV3 = function mapFixtureV3(fixture) {
      if (fixture.json) {
        this['' + fixture.endpoint].andReturnJSON(fixture.json);
      } else {
        this['' + fixture.endpoint].andCallMethod(fixture.method);
      }

      return fixture;
    };MockWebServer.prototype.

    setUseDefaults = function setUseDefaults() {var useDefaults = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.useDefaults = useDefaults;
    };MockWebServer.prototype.

    startWithDefaults = function startWithDefaults() {
      this.setUseDefaults(true);
      return this.start();
    };return MockWebServer;}(BaseWebServer);


  return MockWebServer;
};
//# sourceMappingURL=MockWebServer.js.map